'use strict';

import {
    fetchReport,
} from "../ds.js";

document.addEventListener('readystatechange', async () => {
    const report = await fetchReport(location.search.replace("?id=", ''));

    const resKeys = Object.keys(report.resource);
    // Default value...
    let resType = 'Object';

    if (resKeys.length) {
        resType = resKeys[0].split(' ')[0]; 
        document.querySelector('#rep-tit')
            .innerText = `${resType} ${report.displayname}`;
    
        const repTable = document.querySelector('#resource tbody');

        // TODO manage files and nested objects
        // e.g. if (typeof report.resource[key] == 'object') ...
        for (const key of resKeys) {
            const row = document.createElement('tr');

            if (!key.includes('Coordinates')) {
                row.innerHTML = `
                    <td class="text-bold">${key.replace(resType, '')}</td>
                    <td>${report.resource[key]}</td>
                `;
            }

            repTable.appendChild(row);
        }
    }
})